function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

// Utility: generic builder for template literal tags, using `encode` for each substitution
var createTag = function createTag(encode) {
  return function (stringParts) {
    for (var _len = arguments.length, substitutions = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      substitutions[_key - 1] = arguments[_key];
    }

    return substitutions.reduce(function (prev, cur, i) {
      return prev + encode(cur) + stringParts[i + 1];
    }, stringParts[0]);
  };
};

export var rawSymbol = Symbol('uri.raw');

var representAsString = function representAsString(value) {
  if (value === undefined) {
    throw new TypeError('Cannot encode URI component, given `undefined`');
  } else if (typeof value === 'string') {
    return value;
  } else if (typeof value === 'number') {
    if (Number.isNaN(value)) {
      throw new TypeError('Cannot encode URI component, given NaN');
    } else if (!Number.isFinite(value)) {
      throw new TypeError("Cannot encode URI component, given ".concat(String(value)));
    }

    return String(value);
  } else if (typeof value === 'bigint') {
    return String(value);
  } else {
    throw new TypeError("Cannot encode URI component, given value of unsupported type: ".concat(_typeof(value)));
  }
};

var encodeComponent = function encodeComponent(value) {
  // Sanity check: make sure we have `encodeURIComponent` (available in browsers, Node)
  if (typeof encodeURIComponent !== 'function') {
    throw new TypeError("Missing encodeURIComponent");
  } // RFC 3986 compliant URI encoding
  // See: https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/encodeURIComponent


  return encodeURIComponent(value).replace(/[!'()*]/g, function (c) {
    return '%' + c.charCodeAt(0).toString(16).toUpperCase();
  });
};

var encode = function encode(value) {
  if (_typeof(value) === 'object' && value !== null && rawSymbol in value) {
    return representAsString(value[rawSymbol]);
  }

  var valueAsString = representAsString(value);
  return encodeComponent(valueAsString);
};

export var raw = function raw(value) {
  return _defineProperty({}, rawSymbol, value);
};
var uri = createTag(encode);
uri.raw = raw;
export default uri;
//# sourceMappingURL=uri.mjs.map